思路:nums为给定的数组,动态规划:

设 一维数组:dp[i] 表示 以第i个元素为结尾的一段最大子序和。

1)若dp[i-1]小于0,则dp[i]加上前面的任意长度的序列和都会小于nums[i],则 dp[i] = nums[i];

2)  若dp[i-1] 不小于0, 则 dp[i] = dp[i-1] + nums[i];

边界条件:dp[0] = nums[0]  (nums数组的第一个元素的最大长度就是本身)

class Solution {
public:
int maxSubArray(vector<int>& nums) {
int len = nums.size();
if(len == ) return ;
if(len == ) return nums[];
vector<int> dp(len, ); //dp[i]: 以第i个元素为结尾的最大子序列和
dp[] = nums[];
int max_num = dp[];
for(int i=; i<len; i++){
if(dp[i-] > )
dp[i] = dp[i-] +nums[i];
else
dp[i] = nums[i];
max_num = max(max_num, dp[i]);
}
return max_num;
}
};

最长公共子序列:

https://www.nowcoder.com/courses/6/8/3

#include<bits/stdc++.h>
using namespace std;
int longestsub(string a, string b){
int a_s = a.size(), b_s = b.size();
int N = (a_s >= b_s)? a_s: b_s;
int dp[N+][N+];
memset(dp, , sizeof(dp));
if(a_s<= || b_s<=)
return ;
for(int i=; i<=a_s; i++){
for(int j=; j<=b_s; j++){
if(a[i-]==b[j-])
dp[i][j] = dp[i-][j-]+;
else
dp[i][j] = max(dp[i-][j], dp[i][j-]);
//cout<<dp[i][j]<<" ";
}
//cout<<endl;
}
return dp[a_s][b_s];
}
int main(){
string a, b;
while(cin>>a>>b){
int res = longestsub(a,b);
cout<<res<<endl;
}
return ;
}

568 Maximum Vacation Days 最大化休假日

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation:
Ans = 6 + 3 + 3 = 12.
One of the best strategies is:
1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.)
2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation:
Ans = 1 + 1 + 1 = 3.
Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.

Example 3:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21
One of the best strategies is:
1st week : stay at city 0, and play 7 days.
2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.

题目大意:

给定N个城市,K周时间。
矩阵flights描述N个城市之间是否存在航班通路。
若flights[i][j] = 1,表示i与j存在通路,否则表示不存在。特别的,flights[i][i]恒等于0。
矩阵days表示可以在某城市逗留的最长天数。
例如days[i][j] = k,表示第i个城市第j周最长可以逗留k天。
初始位于0号城市,每周可以选择一个能够到达的城市逗留(也可以留在当前城市)。
求最优策略下的最长逗留总天数。
注意:
  1. N和K是正整数,范围[1, 100]
  2. 矩阵flights的元素范围[0, 1]
  3. 矩阵days的元素范围[0, 7]

思路:

解题思路:

动态规划(Dynamic Programming)
dp[w][c]表示第w周选择留在第c个城市可以获得的最大总收益

初始令dp[w][0] = 0, dp[w][1 .. c - 1] = -1

当dp[w][c] < 0时,表示第c个城市在第w周时还不可达。
状态转移方程:
for w in ( .. K)
for sc in ( .. N)
if dp[w][sc] < :
continue
for tc in ( .. N)
if sc == tc or flights[sc][tc] == :
dp[w + ][tc] = max(dp[w + ][tc], dp[w][sc] + days[tc][w])
class Solution {
public:
int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
int N = flights.size();
int K = days[].size(); vector<vector<int>> dp(K, vector<int>(N, ));
vector<vector<bool>> reach(K, vector<bool>(N, false)); // first week, no guesses for the previous city
for (int city = ; city < N; ++city)
if (city == || flights[][city]) {
dp[][city] = days[city][]; //第0周留在city可获得的最大收益==在city逗留的最大天数
reach[][city] = true; //第0周可达city
} // topological order (week)
for (int week = ; week < K; ++week) {
// current city
for (int city = ; city < N; ++city) {
// Subproblem: guess a previous city
for (int prevCity = ; prevCity < N; ++prevCity) {
if (reach[week - ][prevCity] && (city == prevCity || flights[prevCity][city])) {
dp[week][city] = max(dp[week][city], dp[week - ][prevCity] + days[city][week]);
reach[week][city] = true;
}
}
}
} int res = ;
for (int city = ; city < N; ++city)
res = max(res, dp[K - ][city]); return res; } };

leetcode 53 最大子序列之和(动态规划)的更多相关文章

  1. 小旭讲解 LeetCode 53. Maximum Subarray 动态规划 分治策略

    原题 Given an integer array nums, find the contiguous subarray (containing at least one number) which ...

  2. [array] leetcode - 53. Maximum Subarray - Easy

    leetcode - 53. Maximum Subarray - Easy descrition Find the contiguous subarray within an array (cont ...

  3. hdu1003 Max Sum【最大连续子序列之和】

    题目链接:https://vjudge.net/problem/HDU-1003 题目大意:给出一段序列,求出最大连续子序列之和,以及给出这段子序列的起点和终点. 解题思路:最长连续子序列之和问题其实 ...

  4. [LeetCode] 4Sum 四数之和

    Given an array S of n integers, are there elements a, b, c, and d in S such that a + b + c + d = tar ...

  5. leetcode:House Robber(动态规划dp1)

    You are a professional robber planning to rob houses along a street. Each house has a certain amount ...

  6. CJOJ 2044 【一本通】最长公共子序列(动态规划)

    CJOJ 2044 [一本通]最长公共子序列(动态规划) Description 一个给定序列的子序列是在该序列中删去若干元素后得到的序列.确切地说,若给定序列X,则另一序列Z是X的子序列是指存在一个 ...

  7. C#版 - Leetcode 633. 平方数之和 - 题解

    版权声明: 本文为博主Bravo Yeung(知乎UserName同名)的原创文章,欲转载请先私信获博主允许,转载时请附上网址 http://blog.csdn.net/lzuacm. C#版 - L ...

  8. 【LOJ#6074】子序列(动态规划)

    [LOJ#6074]子序列(动态规划) 题面 LOJ 题解 考虑一个暴力\(dp\). 设\(f[i][c]\)表示当前在第\(i\)位,并且以\(c\)结尾的子序列个数. 那么假设当前位为\(a\) ...

  9. 【BZOJ2423】最长公共子序列(动态规划)

    [BZOJ2423]最长公共子序列(动态规划) 题面 BZOJ 洛谷 题解 今天考试的时候,神仙出题人\(fdf\)把这道题目作为一个二合一出了出来,我除了orz还是只会orz. 对于如何\(O(n^ ...

随机推荐

  1. code1173 最优贸易

    先正向从1点出发SPFA,获得min[i],就是到达i点能最低购买到的价格,(起始点到i的路上经过的最小值) 然后反向(将图反向),从n点开始SPFA,获得max[i],就是从i点到终点能够卖出的最大 ...

  2. 迁移ORACLE数据库文件到ASM

    迁移数据文件到ASM 数据库一致性情况下迁移:将数据库启动到mount状态,生成rman copy 语句,然后在rman中执行: SQL> startup mount SQL> selec ...

  3. UnicodeDecodeError: 'ascii' codec can't decode byte 0xe6 in position 12: ordinal not in range(128)问题解决

    今天在验证字符串是否包含的时候报错:UnicodeDecodeError: 'ascii' codec can't decode byte 0xe6 in position 12: ordinal n ...

  4. [GO]方法的继承

    package main import "fmt" type Person struct { name string sex byte age int } func (tmp Pe ...

  5. select右三角消除(转)

    代码如下: select { /*Chrome和Firefox里面的边框是不一样的,所以复写了一下*/ border: solid 1px #; /*很关键:将默认的select选择框样式清除*/ a ...

  6. jQuary总结11:jQuery插件封装---jQuery封装 手风琴 动画插件

    完整代码下载点击我的GitHub: https://github.com/XingJYGo/jquery-accordion 1 手风琴的效果展示如下: 2 封装插件目录结构如下: 主要包括:HTML ...

  7. JS 单例模式

    <parctical common lisp>的作者曾说,如果你需要一种模式,那一定是哪里出了问题.他所说的问题是指因为语言的天生缺陷,不得不去寻求和总结一种通用的解决方案. 不管是弱类型 ...

  8. SourceInsight中 加namespace宏后,无法跳转问题解决

    Option->preferences->languages: C++ language->special, checked Ignore namespace declaration ...

  9. 15、Semantic-UI之导航

    15.1 面包屑导航   在Semantic-UI中有多种样式实现面包屑导航,类似 / > 等. 示例:定义定义基础面包屑导航 <div class="ui container& ...

  10. Redis分布式锁方案